summaryrefslogtreecommitdiff
path: root/munin
diff options
context:
space:
mode:
authorPeter Palfrader <peter@palfrader.org>2011-06-20 09:51:00 +0000
committerweasel <weasel@bc3d92e2-beff-0310-a7cd-cc87d7ac0ede>2011-06-20 09:51:00 +0000
commit08be39dd7cbe60d54bd0387f145aa734823ab02f (patch)
treea01c71f3c4c6d4d6514c256c878e1ee7ec28e758 /munin
parent32f85cc6eb897217e6fd12a588dc231b2229bf31 (diff)
support multiple clusters
git-svn-id: svn+ssh://asteria.noreply.org/svn/weaselutils/trunk@485 bc3d92e2-beff-0310-a7cd-cc87d7ac0ede
Diffstat (limited to 'munin')
-rwxr-xr-xmunin/postgres-WAL-traffic50
-rwxr-xr-xmunin/postgres-WAL-traffic_77
2 files changed, 77 insertions, 50 deletions
diff --git a/munin/postgres-WAL-traffic b/munin/postgres-WAL-traffic
deleted file mode 100755
index 4fc78c7..0000000
--- a/munin/postgres-WAL-traffic
+++ /dev/null
@@ -1,50 +0,0 @@
-#!/bin/bash
-
-# Copyright Peter Palfrader <peter@palfrader.org>
-#
-# Permission is hereby granted, free of charge, to any person obtaining
-# a copy of this software and associated documentation files (the
-# "Software"), to deal in the Software without restriction, including
-# without limitation the rights to use, copy, modify, merge, publish,
-# distribute, sublicense, and/or sell copies of the Software, and to
-# permit persons to whom the Software is furnished to do so, subject to
-# the following conditions:
-#
-# The above copyright notice and this permission notice shall be
-# included in all copies or substantial portions of the Software.
-#
-# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
-# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
-# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
-# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
-# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
-
-if [ "$1" = "autoconf" ]; then
- echo yes
- exit 0
-fi
-
-if [ "$1" = "config" ]; then
- echo 'graph_title Postgres WAL Traffic'
- echo 'graph_args -l 0'
- echo 'graph_vlabel bytes/min'
- echo 'graph_info This graph shows amount of transaction log traffic'
- echo 'walt.label WAL Traffic'
- echo 'walt.cdef walt,60,*'
- echo 'walt.type DERIVE'
- echo 'walt.draw AREA'
- exit 0
-fi
-
-
-INFO=`psql -p 5433 --no-align --command 'SELECT * FROM pg_xlogfile_name_offset(pg_current_xlog_insert_location())' --field-separator ' ' --quiet | tail -n2 | head -n1`
-
-file=`echo "$INFO" | awk '{print $1}'`
-offset=`echo "$INFO" | awk '{print $2}'`
-
-serial=`echo "$file" | cut -b 9- | sed -e s/^0*/0x/`
-
-bytes=$(( serial * 16*1024*1024 + offset ))
-echo echo "walt.value $bytes"
diff --git a/munin/postgres-WAL-traffic_ b/munin/postgres-WAL-traffic_
new file mode 100755
index 0000000..5f033db
--- /dev/null
+++ b/munin/postgres-WAL-traffic_
@@ -0,0 +1,77 @@
+#!/bin/bash
+
+# Copyright 2007, 2011 Peter Palfrader <peter@palfrader.org>
+#
+# Permission is hereby granted, free of charge, to any person obtaining
+# a copy of this software and associated documentation files (the
+# "Software"), to deal in the Software without restriction, including
+# without limitation the rights to use, copy, modify, merge, publish,
+# distribute, sublicense, and/or sell copies of the Software, and to
+# permit persons to whom the Software is furnished to do so, subject to
+# the following conditions:
+#
+# The above copyright notice and this permission notice shall be
+# included in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+
+findconfig() {
+ local conf
+ local thisver thiscluster thisport
+ conf=${0##*postgres-WAL-traffic_}
+ if [ -z "$conf" ]; then
+ echo >&2 "Do not know for which cluster to get stats"
+ exit 1
+ fi
+
+ mycluster=$(
+ pg_lsclusters --no-header | \
+ while read thisver thiscluster thisport dummy; do
+ if [ "${thisver}_${thiscluster}" = "$conf" ] ; then
+ echo $thisport $thisver $thiscluster
+ break
+ fi
+ done
+ )
+
+ if [ -z "$mycluster" ]; then
+ echo >&2 "Did not find port for $conf"
+ exit 1
+ fi
+
+ read port ver cluster <<< "$mycluster"
+}
+
+if [ "$1" = "autoconf" ]; then
+ echo yes
+elif [ "$1" = "suggest" ]; then
+ pg_lsclusters --no-header | while read ver cluster dummy; do
+ echo "${ver}_${cluster}"
+ done
+elif [ "$1" = "config" ]; then
+ findconfig
+ echo "graph_title Postgres WAL Traffic for $cluster (pg $ver on port $port)"
+ echo 'graph_args -l 0'
+ echo 'graph_vlabel bytes/min'
+ echo 'graph_info This graph shows amount of transaction log traffic'
+ echo 'walt.label WAL Traffic'
+ echo 'walt.cdef walt,60,*'
+ echo 'walt.type DERIVE'
+ echo 'walt.draw AREA'
+else
+ findconfig
+ info=$(sudo -u postgres psql -p "$port" --no-align --command 'SELECT * FROM pg_current_xlog_insert_location()' --tuples-only --quiet | tr -d /)
+ info="0x$info"
+ bytes="$(( $info ))"
+ echo "walt.value $bytes"
+fi
+# vim:set et:
+# vim:set ts=4:
+# vim:set shiftwidth=4: